diff --git a/ldap/servers/slapd/schema.c b/ldap/servers/slapd/schema.c
index 6f14893..db59fbd 100644
--- a/ldap/servers/slapd/schema.c
+++ b/ldap/servers/slapd/schema.c
@@ -2378,7 +2378,7 @@ modify_schema_dse (Slapi_PBlock *pb, Slapi_Entry *entryBefore, Slapi_Entry *entr
         if (NULL != new_schema_csn) {
             char csn_str[CSN_STRSIZE + 1];
             csn_set_replicaid(new_schema_csn, 0);
-            csn_set_time(new_schema_csn, current_time());
+            csn_set_time(new_schema_csn, slapi_current_utc_time());
             g_set_global_schema_csn(new_schema_csn);
             slapi_entry_attr_delete(entryBefore, "nsschemacsn");
             csn_as_string(new_schema_csn, PR_FALSE, csn_str);
@@ -7431,7 +7431,7 @@ modify_schema_internal_mod(Slapi_DN *sdn, Slapi_Mods *smods)
         schema_csn = csn_new();
         if (NULL != schema_csn) {
             csn_set_replicaid(schema_csn, 0);
-            csn_set_time(schema_csn, current_time());
+            csn_set_time(schema_csn, slapi_current_utc_time());
             g_set_global_schema_csn(schema_csn);
         }
     } else {
diff --git a/ldap/servers/slapd/slap.h b/ldap/servers/slapd/slap.h
index 5edaf43..70e51c7 100644
--- a/ldap/servers/slapd/slap.h
+++ b/ldap/servers/slapd/slap.h
@@ -72,6 +72,8 @@ static char ptokPBE[34] = "Internal (Software) Token        ";
 #include <sys/socket.h>
 #include <netinet/in.h>
 
+#include <time.h> /* For timespec definitions */
+
 /* Provides our int types and platform specific requirements. */
 #include <slapi_pal.h>
 
@@ -221,6 +223,8 @@ typedef void	(*VFPV)(); /* takes undefined arguments */
 
 #define SLAPD_INVALID_SOCKET_INDEX	(-1)
 
+#define ETIME_BUFSIZ 42         /* room for struct timespec */
+
 /* ============================================================================
  *       CONFIGURATION DEFAULTS
  *
@@ -1475,8 +1479,8 @@ typedef struct op {
 	BerElement	*o_ber;		/* ber of the request		  */
 	ber_int_t	o_msgid;	/* msgid of the request		  */
 	ber_tag_t	o_tag;		/* tag of the request		  */
-	time_t		o_time;		/* time op was initiated	  */
-	PRIntervalTime	o_interval;	/* precise time op was initiated  */
+    struct timespec o_hr_time_rel; /* internal system time op initiated */
+    struct timespec o_hr_time_utc; /* utc system time op initiated */
 	int		o_isroot;	/* requestor is manager		  */
 	Slapi_DN	o_sdn;		/* dn bound when op was initiated */
 	char		*o_authtype;	/* auth method used to bind dn	  */
@@ -1525,7 +1529,7 @@ typedef struct _paged_results {
     int           pr_search_result_count; /* search result count */
     int           pr_search_result_set_size_estimate; /* estimated search result set size */
     int           pr_sort_result_code;    /* sort result put in response */
-    time_t        pr_timelimit;           /* time limit for this request */
+    struct timespec pr_timelimit_hr;      /* expiry time of this request rel to clock monotonic */
     int           pr_flags;
     ber_int_t     pr_msgid;               /* msgid of the request; to abandon */
     PRLock        *pr_mutex;              /* protect each conn structure    */
@@ -1710,15 +1714,15 @@ typedef struct passwordpolicyarray {
   int pw_mintokenlength;
   slapi_onoff_t pw_exp;
   slapi_onoff_t pw_send_expiring;
-  long long pw_maxage;
-  long long pw_minage;
-  long long pw_warning;
+  time_t pw_maxage;
+  time_t pw_minage;
+  time_t pw_warning;
   slapi_onoff_t pw_history;
   int pw_inhistory;
   slapi_onoff_t pw_lockout;
   int pw_maxfailure;
   slapi_onoff_t pw_unlock;
-  long pw_lockduration;
+  time_t pw_lockduration;
   long pw_resetfailurecount;
   int pw_gracelimit;
   slapi_onoff_t pw_is_legacy;
diff --git a/ldap/servers/slapd/slapi-plugin.h b/ldap/servers/slapd/slapi-plugin.h
index 2fc6d68..09fef07 100644
--- a/ldap/servers/slapd/slapi-plugin.h
+++ b/ldap/servers/slapd/slapi-plugin.h
@@ -4826,7 +4826,7 @@ long long slapi_value_get_longlong(const Slapi_Value *value);
 unsigned long long slapi_value_get_ulonglong(const Slapi_Value *value);
 
 /**
- * Retrieves the value of a \c Slapi_Value structure as a long integer.
+ * DEPRECATED: Retrieves the value of a \c Slapi_Value structure as a long integer.
  *
  * \param value Pointer to the value you wish to get as a long integer.
  *        The value could end with D or d for days, H or h for hours,
@@ -4835,16 +4835,12 @@ unsigned long long slapi_value_get_ulonglong(const Slapi_Value *value);
  *         \c Slapi_Value structure.
  * \return \c 0 if there is no value.
  * \return \c -1 if the given value is invalid.
- * \see slapi_value_get_int()
- * \see slapi_value_get_uint()
- * \see slapi_value_get_ulong()
- * \see slapi_value_get_longlong()
- * \see slapi_value_get_ulonglong()
+ * \see slapi_value_get_time_time_t()
  */
-long slapi_value_get_timelong(const Slapi_Value *value);
+long slapi_value_get_timelong(const Slapi_Value *value) __attribute__((deprecated));
 
 /**
- * Retrieves the value of a \c Slapi_Value structure as a long long integer.
+ * DEPRECATED: Retrieves the value of a \c Slapi_Value structure as a long long integer.
  *
  * \param value Pointer to the value you wish to get as a long long integer.
  *        The value could end with D or d for days, H or h for hours,
@@ -4853,13 +4849,29 @@ long slapi_value_get_timelong(const Slapi_Value *value);
  *         \c Slapi_Value structure.
  * \return \c 0 if there is no value.
  * \return \c -1 if the given value is invalid.
+ * \see slapi_value_get_time_time_t()
+ */
+long long slapi_value_get_timelonglong(const Slapi_Value *value) __attribute__((deprecated));
+
+/**
+ * Retrieves the value of a \c Slapi_Value structure as a time_t.
+ *
+ * \param value Pointer to the value you wish to get as a time_t.
+ *        The value could end with D or d for days, H or h for hours,
+ *        M or m for minutes, S or s for seconds, or no extension.
+ * \return A long long integer that corresponds to the value stored in the
+ *         \c Slapi_Value structure.
+ * \return \c 0 if there is no value.
+ * \return \c -1 if the given value is invalid.
  * \see slapi_value_get_int()
  * \see slapi_value_get_uint()
  * \see slapi_value_get_ulong()
  * \see slapi_value_get_longlong()
  * \see slapi_value_get_ulonglong()
+ * \see slapi_value_get_time_time_t()
  */
-long long slapi_value_get_timelonglong(const Slapi_Value *value);
+time_t slapi_value_get_time_time_t(const Slapi_Value *value);
+
 
 /**
  * Gets the length of a value contained in a \c Slapi_Value structure.
@@ -6775,9 +6787,109 @@ int slapi_reslimit_get_integer_limit( Slapi_Connection *conn, int handle,
 /**
  * Returns the current time
  *
+ * CRITICAL: This funciton is NOT THREAD SAFE. DO NOT USE IT.
+ * You MUST use slapi_current_time_hr instead.
+ *
  * \return The current time
  */
-time_t slapi_current_time( void );
+time_t slapi_current_time( void )  __attribute__((deprecated));
+
+/**
+ * Returns the current system time as a hr clock relative to uptime
+ * This means the clock is not affected by timezones
+ * which can normally cause issues with timers. Additionally, this
+ * is a thread safe clock.
+ *
+ * \return timespec of the current relative system time.
+ */
+struct timespec slapi_current_time_hr(void);
+/**
+ * Returns the current system time as a hr clock in UTC timezone.
+ * This clock adjusts with ntp steps, and should NOT be
+ * used for timer information.
+ *
+ * \return timespec of the current UTC time.
+ */
+struct timespec slapi_current_utc_time_hr(void);
+/**
+ * Returns the current system time as a clock in UTC timezone.
+ * This clock adjusts with ntp steps, and should NOT be
+ * used for timer information.
+ *
+ * \return time_t of the current UTC time.
+ */
+time_t slapi_current_utc_time(void);
+
+#define SLAPI_TIMESTAMP_BUFSIZE 32
+/**
+ * Populates a buffer with a timestamp formatted correctly for
+ * directory servers usage. This generally means UTC from localsystem
+ * time and in the format %Y%m%d%H%M%SZ.
+ *
+ * \param char *buf the buffer to populate.
+ * \param size_t bufsize Size of the buffer to populate. Must be at least
+ * SLAPI_TIMESTAMP_BUFSIZE
+ */
+void slapi_timestamp_utc_hr(char *buf, size_t bufsize);
+
+typedef enum {
+    TIMER_CONTINUE,
+    TIMER_EXPIRED
+} slapi_timer_result;
+
+/**
+ * populate a timespec with a time relative to now, that defines
+ * an expiry. IE, current time + timeout. This wraps the internal
+ * clock function to allow us to change clock operations without
+ * changing large parts of the codebase.
+ *
+ * if a negative timeout is provided, we set expire to 0.
+ *
+ * \param timeout the number of seconds relative to now when
+ * the timeout should occur.
+ * \param struct timespec the struct to populate with the relative
+ * time of when we should expire.
+ */
+void slapi_timespec_expire_at(time_t timeout, struct timespec *expire);
+
+/**
+ * populate a timespec with a time relative to start, that defines
+ * an expiry. IE, start time + timeout.
+ *
+ * if a negative timeout is provided, we set expire to 0.
+ *
+ * \param timeout the number of seconds relative to now when
+ * the timeout should occur.
+ * \param struct timespec start the struct containing the start
+ * time we are creating a relative expiry to.
+ * \param struct timespec the struct to populate with the relative
+ * time of when we should expire.
+ */
+void slapi_timespec_expire_rel(time_t timeout, struct timespec *start, struct timespec *expire);
+
+/**
+ * Given a slapi_operation, and a timeout, calculate the expiry
+ * relative to the operations start time. This is used to determine
+ * time outs from op start time + timeout. To check the timeout
+ * you should call slapi_timespec_expire_check.
+ *
+ * \param Slapi_Operation o the operation to use.
+ * \param time_t timeout the timeout in seconds.
+ * \param struct timespec expiry the timespec that will be populated with
+ * the system relative expiry time.
+ */
+void slapi_operation_time_expiry(Slapi_Operation *o, time_t timeout, struct timespec *expiry);
+
+/**
+ * check if a timespec has expired it's lifetime relative to now.
+ * if the timespec is 0, we do not cause a timeout.
+ *
+ * \param timespec to check for validity.
+ * \return slapi_time_result an enum of CONTINUE which means no
+ * expiry has occured, or EXPIRED, to defined tht the time is
+ * up. If timespec is 0, CONTINUE is always returned.
+ */
+slapi_timer_result slapi_timespec_expire_check(struct timespec *expire);
 
 
 /*
@@ -7428,10 +7540,25 @@ Slapi_Regex *slapi_re_comp( const char *pat, const char **error );
  * \return This function returns other values if any error occurred.
  * \warning The regex handler should be released by slapi_re_free().
  */
-int slapi_re_exec( Slapi_Regex *re_handle, const char *subject, time_t time_up );
+int slapi_re_exec( Slapi_Regex *re_handle, const char *subject, time_t time_up ) __attribute__((deprecated));
+/**
+ * Matches a compiled regular expression pattern against a given string.
+ * A thin wrapper of pcre_exec.
+ *
+ * \param re_handle The regex handler returned from slapi_re_comp.
+ * \param subject A string to be checked against the compiled pattern.
+ * returns immediately.  (-1) means no time limit.
+ * \return This function returns 0 if the string did not match.
+ * \return This function returns 1 if the string matched.
+ * \return This function returns other values if any error occurred.
+ * \warning The regex handler should be released by slapi_re_free().
+ */
+int32_t slapi_re_exec_nt( Slapi_Regex *re_handle, const char *subject);
 /**
  * Substitutes '&' or '\#' in the param src with the matched string.
  *
+ * This is identical to slapi_re_exec, except with no timeout.
+ *
  * \param re_handle The regex handler returned from slapi_re_comp.
  * \param subject A string checked against the compiled pattern.
  * \param src A given string which could contain the substitution symbols.
@@ -8066,6 +8193,44 @@ int slapi_is_special_rdn(const char *rdn, int flag);
  */
 void    DS_Sleep(PRIntervalTime ticks);
 
+
+#ifdef HAVE_CLOCK_GETTIME
+/**
+ * Diffs two timespects a - b into *diff. This is useful with
+ * clock_monotonic to find time taken to perform operations.
+ *
+ * \param struct timespec a the "end" time.
+ * \param struct timespec b the "start" time.
+ * \param struct timespec c the difference.
+ */
+void slapi_timespec_diff(struct timespec *a, struct timespec *b, struct timespec *diff);
+/**
+ * Given an operation, determine the time elapsed since the op
+ * began.
+ *
+ * \param Slapi_Operation o - the operation which is inprogress
+ * \param struct timespec *elapsed - location where the time difference will be
+ * placed.
+ */
+void slapi_operation_time_elapsed(Slapi_Operation *o, struct timespec *elapsed);
+/**
+ * Given an operation, see it's initiated time based on clock_monotonic
+ * this is useful for timeout parameters and checks.
+ *
+ * \param Slapi_Operation o - the operation that is in progress
+ * \param struct timespec *initiated - location where we will populate the init time.
+ */
+void slapi_operation_time_initiated(Slapi_Operation *o, struct timespec *initiated);
+/**
+ * Given an operation and a timeout, return a populate struct with the expiry
+ * time of the operation suitable for checking with slapi_timespec_expire_check
+ *
+ * \param Slapi_Operation o - the operation that is in progress
+ * \param time_t timeout the seconds relative to operation initiation to expiry at.
+ * \param struct timespec *expiry the timespec to popluate with the relative expiry.
+ */
+#endif
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/ldap/servers/slapd/slapi-private.h b/ldap/servers/slapd/slapi-private.h
index 5703375..97cd964 100644
--- a/ldap/servers/slapd/slapi-private.h
+++ b/ldap/servers/slapd/slapi-private.h
@@ -265,10 +265,6 @@ void* csngen_register_callbacks(CSNGen *gen, GenCSNFn genFn, void *genArg,
 /* unregisters callbacks registered via call to csngenRegisterCallbacks */
 void csngen_unregister_callbacks(CSNGen *gen, void *cookie);
 
-/* this functions is periodically called from daemon.c to
-   update time used by all generators */
-void csngen_update_time(void);
-
 /* debugging function */
 void csngen_dump_state (const CSNGen *gen);
 
@@ -1164,12 +1160,14 @@ char* format_localTime(time_t from);
 time_t read_localTime(struct berval* from);
 time_t parse_localTime(char* from);
 void write_localTime(time_t from, struct berval* into);
-time_t current_time( void );
+time_t current_time( void ) __attribute__((deprecated));
 char* format_genTime(time_t from);
 void write_genTime(time_t from, struct berval* into);
 time_t read_genTime(struct berval* from);
 time_t parse_genTime(char* from);
-long parse_duration(char *value);
+long parse_duration(char *value) __attribute__((deprecated));
+long parse_duration_32bit(char *value);
+time_t parse_duration_time_t(char *value);
 char *gen_duration(long duration);
 
 /* Client SSL code */
@@ -1365,7 +1363,7 @@ char *slapi_getSSLVersion_str(PRUint16 vnum, char *buf, size_t bufsize);
  *    Failure: -1
  */
 time_t slapi_parse_duration(const char *value);
-long long slapi_parse_duration_longlong(const char *value);
+long long slapi_parse_duration_longlong(const char *value) __attribute__((deprecated));
 int slapi_is_duration_valid(const char *value);
 
 /**
diff --git a/ldap/servers/slapd/time.c b/ldap/servers/slapd/time.c
index 16467af..2dc5522 100644
--- a/ldap/servers/slapd/time.c
+++ b/ldap/servers/slapd/time.c
@@ -23,71 +23,6 @@
 unsigned long strntoul( char *from, size_t len, int base );
 #define mktime_r(from) mktime (from) /* possible bug: is this thread-safe? */
 
-static time_t	currenttime;
-static int	currenttime_set = 0;
-/* XXX currenttime and currenttime_set are used by multiple threads,
- * concurrently (one thread sets them, many threads read them),
- * WITHOUT SYNCHRONIZATION.  If assignment to currenttime especially
- * is not atomic, current_time() will return bogus values, and
- * bogus behavior may ensue.  We think this isn't a problem, because
- * currenttime is a static variable, and defined first in this module;
- * consequently it's aligned, and doesn't cross cache lines or
- * otherwise run afoul of multiprocessor weirdness that might make
- * assignment to it non-atomic.
- */
-
-#ifndef HAVE_TIME_R
-PRLock  *time_func_mutex;
-
-int gmtime_r(
-    const time_t *timer,
-    struct tm *result
-)
-{
-    if ( result == NULL ) {
-	return -1;
-    }
-    PR_Lock( time_func_mutex );
-    memcpy( (void *) result, (const void *) gmtime( timer ),
-		sizeof( struct tm ));
-    PR_Unlock( time_func_mutex );
-    return 0;
-}
-
-int localtime_r(
-    const time_t *timer,
-    struct tm *result
-)
-{
-    if ( result == NULL ) {
-	return -1;
-    }
-    PR_Lock( time_func_mutex );
-    memcpy( (void *) result, (const void *) localtime( timer ),
-		sizeof( struct tm ));
-    PR_Unlock( time_func_mutex );
-    return 0;
-}
-
-
-int ctime_r(
-    const time_t *timer,
-    char *buffer,
-    int buflen
-)
-{
-    if (( buffer == NULL ) || ( buflen < 26)) {
-	return -1;
-    }
-    PR_Lock( time_func_mutex );
-    memset( buffer, 0, buflen );
-    memcpy( buffer, ctime( timer ), 26 );
-    PR_Unlock( time_func_mutex );
-    return 0;
-}
-#endif /* HAVE_TIME_R */
-
-
 char *
 get_timestring(time_t *t)
 {
@@ -103,8 +38,9 @@ get_timestring(time_t *t)
 void
 free_timestring(char *timestr)
 {
-    if ( timestr != NULL )
+    if ( timestr != NULL ) {
         slapi_ch_free((void**)&timestr);
+    }
 }
 
 /*
@@ -116,54 +52,71 @@ free_timestring(char *timestr)
  * Note: during server startup, poll_current_time() is not called at all so
  * current_time() just calls through to time() until poll_current_time() starts
  * to be called.
+ *
+ * WARNING: THIS IS NOT THREADSAFE.
  */
 time_t
 poll_current_time()
 {
-    if ( !currenttime_set ) {
-	currenttime_set = 1;
-    }
-
-    time( &currenttime );
-    return( currenttime );
+    return 0;
 }
 
 time_t
 current_time( void )
 {
-    if ( currenttime_set ) {
-        return( currenttime );
-    } else {
-        return( time( (time_t *)0 ));
-    }
+    /*
+     * For now wrap UTC time, but this interface
+     * but this should be removed in favour of the
+     * more accurately named slapi_current_utc_time
+     */
+    struct timespec now;
+    clock_gettime(CLOCK_REALTIME, &now);
+    return now.tv_sec;
 }
 
 time_t
 slapi_current_time( void )
 {
-    return current_time();
+    return slapi_current_utc_time();
+}
+
+struct timespec
+slapi_current_rel_time_hr( void ) {
+    struct timespec now;
+    clock_gettime(CLOCK_MONOTONIC, &now);
+    return now;
+}
+
+struct timespec
+slapi_current_utc_time_hr(void) {
+    struct timespec ltnow;
+    clock_gettime(CLOCK_REALTIME, &ltnow);
+    return ltnow;
+}
+
+time_t
+slapi_current_utc_time(void) {
+    struct timespec ltnow;
+    clock_gettime(CLOCK_REALTIME, &ltnow);
+    return ltnow.tv_sec;
+}
+
+void
+slapi_timestamp_utc_hr(char *buf, size_t bufsize) {
+    PR_ASSERT(bufsize >= SLAPI_TIMESTAMP_BUFSIZE);
+    struct timespec ltnow;
+    struct tm utctm;
+    clock_gettime(CLOCK_REALTIME, &ltnow);
+    gmtime_r(&(ltnow.tv_sec), &utctm);
+    strftime(buf, bufsize, "%Y%m%d%H%M%SZ", &utctm);
 }
 
 time_t
 time_plus_sec (time_t l, long r)
     /* return the point in time 'r' seconds after 'l'. */
 {
-    /* On many (but not all) platforms this is simply l + r;
-       perhaps it would be better to implement it that way. */
-    struct tm t;
-    if (r == 0) return l; /* performance optimization */
-    localtime_r (&l, &t);
-    /* Conceptually, we want to do: t.tm_sec += r;
-       but to avoid overflowing fields: */
-    r += t.tm_sec;  t.tm_sec  = r % 60; r /= 60;
-    r += t.tm_min;  t.tm_min  = r % 60; r /= 60;
-    r += t.tm_hour; t.tm_hour = r % 24; r /= 24;
-    t.tm_mday += r; /* may be > 31; mktime_r() must handle this */
-
-    /* These constants are chosen to work when the maximum
-       field values are 127 (the worst case) or more.
-       Perhaps this is excessively conservative. */
-    return mktime_r (&t);
+    PR_ASSERT(r >= 0);
+    return l + (time_t)r;
 }
 
 
@@ -217,7 +170,6 @@ format_localTime_log(time_t t, int initsize __attribute__((unused)), char *buf,
     return 0;
 }
 
-#ifdef HAVE_CLOCK_GETTIME
 /*
  * format_localTime_hr_log will take a time value, and prepare it for
  * log printing.
@@ -268,7 +220,62 @@ format_localTime_hr_log(time_t t, long nsec, int initsize __attribute__((unused)
     *bufsize = strlen(buf);
     return 0;
 }
-#endif /* HAVE_CLOCK_GETTIME */
+
+void
+slapi_timespec_diff(struct timespec *a, struct timespec *b, struct timespec *diff) {
+    /* Now diff the two */
+    time_t sec = a->tv_sec - b->tv_sec;
+    int32_t nsec = a->tv_nsec - b->tv_nsec;
+
+    if (nsec < 0) {
+        /* It's negative so take one second */
+        sec -= 1;
+        /* And set nsec to to a whole value */
+        nsec = 1000000000 - nsec;
+    }
+
+    diff->tv_sec = sec;
+    diff->tv_nsec = nsec;
+}
+
+void
+slapi_timespec_expire_at(time_t timeout, struct timespec *expire) {
+    if (timeout <= 0) {
+        expire->tv_sec = 0;
+        expire->tv_nsec = 0;
+    } else {
+        clock_gettime(CLOCK_MONOTONIC, expire);
+        expire->tv_sec += timeout;
+    }
+}
+
+void
+slapi_timespec_expire_rel(time_t timeout, struct timespec *start, struct timespec *expire) {
+    if (timeout <= 0) {
+        expire->tv_sec = 0;
+        expire->tv_nsec = 0;
+    } else {
+        expire->tv_sec = start->tv_sec + timeout;
+        expire->tv_nsec = start->tv_nsec;
+    }
+}
+
+slapi_timer_result
+slapi_timespec_expire_check(struct timespec *expire) {
+    /*
+     * Check this first, as it makes no timeout virutally free.
+     */
+    if (expire->tv_sec == 0 && expire->tv_nsec == 0) {
+        return TIMER_CONTINUE;
+    }
+    struct timespec now;
+    clock_gettime(CLOCK_MONOTONIC, &now);
+    if (now.tv_sec > expire->tv_sec ||
+        (expire->tv_sec == now.tv_sec && now.tv_sec > expire->tv_nsec)) {
+        return TIMER_EXPIRED;
+    }
+    return TIMER_CONTINUE;
+}
 
 char*
 format_localTime (time_t from)
@@ -348,7 +355,7 @@ format_genTime (time_t from)
     struct tm t;
 
     gmtime_r (&from, &t);
-    into = slapi_ch_malloc (20);
+    into = slapi_ch_malloc (SLAPI_TIMESTAMP_BUFSIZE);
     strftime(into, 20, "%Y%m%d%H%M%SZ", &t);
     return into;
 }
@@ -456,7 +463,7 @@ parse_genTime (char* from)
  *   Failure: -1
  */
 long
-parse_duration(char *value)
+parse_duration_32bit(char *value)
 {
     char *input = NULL;
     char *endp;
@@ -523,8 +530,8 @@ bail:
     return duration;
 }
 
-long long
-parse_duration_longlong(char *value)
+time_t
+parse_duration_time_t(char *value)
 {
     char *input = NULL;
     char *endp;
@@ -584,7 +591,7 @@ parse_duration_longlong(char *value)
     duration *= times;
 bail:
     if (duration == -1) {
-        slapi_log_err(SLAPI_LOG_ERR, "parse_duration_longlong",
+        slapi_log_err(SLAPI_LOG_ERR, "parse_duration_time_t",
                 "Invalid duration (%s)\n", value?value:"null");
     }
     slapi_ch_free_string(&input);
@@ -594,13 +601,13 @@ bail:
 time_t
 slapi_parse_duration(const char *value)
 {
-    return (time_t)parse_duration((char *)value);
+    return parse_duration_time_t((char *)value);
 }
 
 long long
 slapi_parse_duration_longlong(const char *value)
 {
-    return parse_duration_longlong((char *)value);
+    return parse_duration_time_t((char *)value);
 }
 
 static int
diff --git a/ldap/servers/slapd/uuid.c b/ldap/servers/slapd/uuid.c
index 333321c..14e75dc 100644
--- a/ldap/servers/slapd/uuid.c
+++ b/ldap/servers/slapd/uuid.c
@@ -883,7 +883,7 @@ static void get_system_time(uuid_time_t *uuid_time)
 {
 	time_t cur_time;
 
-	cur_time = current_time ();
+	cur_time = slapi_current_utc_time();
 
 	/* Offset between UUID formatted times and time() formatted times.
        UUID UTC base time is October 15, 1582. time() base time is January 1, 1970.*/
diff --git a/ldap/servers/slapd/value.c b/ldap/servers/slapd/value.c
index 63a1ca9..879651b 100644
--- a/ldap/servers/slapd/value.c
+++ b/ldap/servers/slapd/value.c
@@ -503,7 +503,7 @@ slapi_value_get_timelong(const Slapi_Value *value)
         p = slapi_ch_malloc(value->bv.bv_len + 1);
         memcpy (p, value->bv.bv_val, value->bv.bv_len);
         p [value->bv.bv_len] = '\0';
-        r = parse_duration(p);
+        r = parse_duration_32bit(p);
         slapi_ch_free((void **)&p);
 	}
 	return r;
@@ -519,12 +519,29 @@ slapi_value_get_timelonglong(const Slapi_Value *value)
 		p = slapi_ch_malloc(value->bv.bv_len + 1);
 		memcpy(p, value->bv.bv_val, value->bv.bv_len);
 		p[value->bv.bv_len] = '\0';
-		r = slapi_parse_duration_longlong(p);
+		r = parse_duration_time_t(p);
 		slapi_ch_free_string(&p);
 	}
 	return r;
 }
 
+time_t
+slapi_value_get_time_time_t(const Slapi_Value *value)
+{
+	long long r = 0;
+	if(value)
+	{
+		char *p;
+		p = slapi_ch_malloc(value->bv.bv_len + 1);
+		memcpy(p, value->bv.bv_val, value->bv.bv_len);
+		p[value->bv.bv_len] = '\0';
+		r = parse_duration_time_t(p);
+		slapi_ch_free_string(&p);
+	}
+	return r;
+}
+
+
 int
 slapi_value_compare(const Slapi_Attr *a,const Slapi_Value *v1,const Slapi_Value *v2)
 {
-- 
1.8.3.1

